#include <stdio.h>
#include <stdlib.h>
#define RADIX 10	
#define DIGIT 2		
#define N 8
int ken[N]={27, 6, 78, 2, 62, 12, 60, 16};

typedef struct QNode {
	int data;
	struct QNode *link;
} QNode;

typedef struct {
	QNode *front, *rear;
} LQ_Type;

LQ_Type *create_LQ() {
	LQ_Type *LQ;
	LQ = (LQ_Type *)malloc(sizeof(LQ_Type));
	LQ->front = NULL;
	LQ->rear = NULL;
	return LQ;
}

int is_Empty(LQ_Type *LQ) {
	if (LQ->front == NULL) return 1;
	else return 0;
}

void insert_Q(LQ_Type *LQ, int item) {
	QNode *newNode = (QNode *)malloc(sizeof(QNode));
	newNode->data = item;
	newNode->link = NULL;
	if (LQ->front == NULL) {
		LQ->front = newNode;
		LQ->rear = newNode;
	}
	else {
		LQ->rear->link = newNode;
		LQ->rear = newNode;
	}
}

int delete_Q(LQ_Type *LQ) {
	QNode *old = LQ->front;
	int item;
	if (is_Empty(LQ)) return 0;
	else {
		item = old->data;
		LQ->front = LQ->front->link;
		if (LQ->front == NULL)
			LQ->rear = NULL;
		free(old);
		return item;
	}
} 

void r_sort(int s_result[], int n) {
	int i, bucket, d, factor = 1;
	int j; 

	LQ_Type *Q[RADIX];  
	for (bucket = 0; bucket<RADIX; bucket++) {
		Q[bucket] = create_LQ();
	}

	for (d = 0; d<DIGIT; d++) {
		for (i = 0; i<n; i++)
			insert_Q(Q[(s_result[i] / factor) % 10], s_result[i]);

		for (bucket = 0, i = 0; bucket<RADIX; bucket++)   
	         while (!is_Empty(Q[bucket])) 
				   s_result[i++] = delete_Q(Q[bucket]);
		
		factor = factor * 10;
	   
	    printf("\n==> %d ܰ : ", d + 1);
	    for (i = 0; i<n; i++)  printf(" %d", s_result[i]);
	}
}

void main() 
{
	int i;

    printf("<< (radix sort):  >>\n\n");
	
    printf("* before sorting data:  ");
	for(i=0; i<N; i++) printf("%3d", ken[i]);
	
    printf("\n============================================\n");
	
	r_sort(ken, N);

    printf("\n==========================================\n\n");
    printf("* after sorting data: ");
	for (i = 0; i<N; i++)  printf(" %d", ken[i]);
    printf("\n");

	getchar();
}