#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#define MAX(a,b) ((a>b) ? a:b)

typedef int e;

typedef struct t_Node {
	struct t_Node *left;
	e key;
	struct t_Node *right;
}t_Node;

t_Node* r_LL(t_Node *parent) {
	t_Node *child = parent->left;
	parent->left = child->right;
	child->right = parent;
	return child;
}

t_Node* r_RR(t_Node *parent) {
	t_Node *child = parent->right;
	parent->right = child->left;
	child->left = parent;
	return child;
}

t_Node* r_LR(t_Node *parent) {
	t_Node *child = parent->left;
	parent->left = r_RR(child);
	return r_LL(parent);
}

t_Node* r_RL(t_Node *parent) {
	t_Node *child = parent->right;
	parent->right = r_LL(child);
	return r_RR(parent);
}

int get_H(t_Node* p) {
	int height = 0;
	if (p != NULL) height = MAX(get_H(p->left), get_H(p->right)) + 1;
	return height;
}

int get_BF(t_Node* p) {
	if (p == NULL) return 0;
	return get_H(p->left) - get_H(p->right);
}

t_Node* rebalance_AVL(t_Node** p) {
	int BF = get_BF(*p);
	if (BF > 1) {
		if (get_BF((*p)->left) > 0)
			     *p = r_LL(*p);
		else    *p = r_LR(*p);
	}
	else if (BF < -1) {
		if (get_BF((*p)->right) < 0)
			 *p = r_RR(*p);
		else *p = r_RL(*p);
	}
	return *p;
}

t_Node* insert_AVL(t_Node** root, e x) {	
	if (*root == NULL) {
		*root = (t_Node*)malloc(sizeof(t_Node));
		(*root)->key = x;
		(*root)->left = NULL;
		(*root)->right = NULL;		
	}
	else if (x < (*root)->key) {
		(*root)->left = insert_AVL(&((*root)->left), x);
		*root = rebalance_AVL(root);
	}
	else if (x >(*root)->key) {
		(*root)->right = insert_AVL(&((*root)->right), x);
		*root = rebalance_AVL(root);
	}
	else {
		printf("\n  Ű ! \n");
		exit(1);
	}
	return *root;
}

t_Node* s_AVL(t_Node* root, e x) {
	t_Node* p;
	int count = 0;
	p = root;
	while (p != NULL) {
		count++;
		printf("\n %3d°: %3d", count, p->key);
		
		if (x < p->key) p = p->left;
		else if (x == p->key) {
			printf(" ==>%3d° ˻ : %3d", count, p->key);
			return p;
		}
		else p = p->right;
	}
	count++;
	printf(" ==>%3d° ˻ : ã Ű !!", count);
	return p;
}

void p_Inorder(t_Node* root) {
	if (root) {
		p_Inorder(root->left);
		printf("%3d ", root->key);
		p_Inorder(root->right);
	}
}

int main() {
	t_Node* r_AVL = NULL;

	r_AVL = insert_AVL(&r_AVL, 45);
	insert_AVL(&r_AVL, 26); insert_AVL(&r_AVL, 11);
	insert_AVL(&r_AVL, 15); insert_AVL(&r_AVL, 57);
	insert_AVL(&r_AVL, 33); insert_AVL(&r_AVL, 41);
	insert_AVL(&r_AVL, 39); insert_AVL(&r_AVL, 6);
	insert_AVL(&r_AVL, 23); insert_AVL(&r_AVL, 21);
	printf("\n ** AVLƮ(:left-root-right) ** \n\n");
	p_Inorder(r_AVL);

	printf("\n\n AVLƮ[45 ˻] : ");
	s_AVL(r_AVL, 45);
	printf("\n\n AVLƮ[15 ˻] : ");
	s_AVL(r_AVL, 15);
	printf("\n\n AVLƮ[57 ˻] : ");
	s_AVL(r_AVL, 57);
    printf("\n\n AVLƮ[41 ˻] : ");
	s_AVL(r_AVL, 41);
    printf("\n\n AVLƮ[25 ˻] : ");
	s_AVL(r_AVL, 25); 
		
	getchar();
}