#include <stdio.h>
#include <stdlib.h> 

#define MAX(a,b) ((a>b)?a:b)
#define MAX_DEGREE 70
#define MAX_TERMS  70

typedef struct  Poly1 {            
	int deg;              
	float coef[MAX_DEGREE]; 
} p1;

typedef struct Poly2 {             
	int coef2;          
	int expon2;
};

struct Poly2 p2[MAX_TERMS] = {{3,9}, {-9,6}, {-2,4}, {2,1}, 
                              {4,4}, {3,3}, {-3,2}};

int avail = 7;

p1 addPoly1(p1, p1);
void printPoly1(p1);

char comparePoly2(int, int);
void attachPoly2(int, int);
void addPoly2(int, int, int, int, int, int);
void printPoly2();

void main() {
	int Cs, Ce;

	p1 A = { 9,{ 3,0,0,-9,0,-2,0,0,2,0} };   
	p1 B = { 4,{ 4,3,-3,0,0} };   		
	p1 C;
	C = addPoly1(A, B);    

	printf("=== ׽ [Ҵ׽]: A(x)+B(x)=C(x) =======");
	printf("\nA(x) =");  printPoly1(A);   
	printf("B(x) =");  printPoly1(B);   
	printf("C(x)=");  printPoly1(C);   

	printf("\n\n=== ׽ [Ҵ׽]: A(x)+B(x)=C(x) =======\n");
	addPoly2(0, 3, 4, 6, &Cs, &Ce);
	printPoly2();  

	getchar();
}

p1 addPoly1(p1 A, p1 B) {
	p1 C;   
	int A_index = 0, B_index = 0, C_index = 0;
	int A_deg = A.deg, B_deg = B.deg;
	C.deg = MAX(A.deg, B.deg);

	while (A_index <= A.deg && B_index <= B.deg) {
		if (A_deg > B_deg) {
			C.coef[C_index++] = A.coef[A_index++];
			A_deg--;
		}
		else if (A_deg == B_deg) {
			C.coef[C_index++] = A.coef[A_index++] + B.coef[B_index++];
			A_deg--;
			B_deg--;
		}
		else { C.coef[C_index++] = B.coef[B_index++];
			   B_deg--;
		};
	};
	return C;    
};

void printPoly1(p1 P) {
	int i, deg;
	deg = P.deg;

	for (i = 0; i <= P.deg; i++) {
		printf("(%2.0fx^%d)", P.coef[i], deg--);
		if (i < P.deg) printf("+");
	};
	printf("\n");
};

char comparePoly2(int a, int b) {
	if(a>b) return '>';
	else if(a==b) return '=';
	else return '<';
}

void attachPoly2(int coef2, int expon2) {
	if( avail > MAX_TERMS ) { 
		fprintf(stderr, "  ʹ \n");
		exit(1);
	};
	p2[avail].coef2=coef2;
	p2[avail++].expon2=expon2;
};

void addPoly2(int As, int Ae, int Bs, int Be, int *Cs, int *Ce) {
	int tmpcoef;
	*Cs = avail;

	while(As <= Ae && Bs <= Be)
		switch (comparePoly2(p2[As].expon2, p2[Bs].expon2)) {
		case '>': attachPoly2(p2[As].coef2, p2[As].expon2); 
	              As++;	break;
		case '=': tmpcoef = p2[As].coef2 + p2[Bs].coef2;
			     if (tmpcoef)
				    attachPoly2(tmpcoef, p2[As].expon2);
			        As++; Bs++; break;    
		case '<': attachPoly2(p2[Bs].coef2, p2[Bs].expon2); 
	              Bs++;	break;
    };

	for(;As<=Ae;As++) attachPoly2(p2[As].coef2, p2[As].expon2);
	for(;Bs<=Be;Bs++) attachPoly2(p2[Bs].coef2, p2[Bs].expon2);
	*Ce = avail - 1;
};

void printPoly2() {
	int i,j; 

	 printf("A(x) ="); 
   	 for(i=0; i<avail; i++) {
		 printf("(%d x^ %d)", p2[i].coef2, p2[i].expon2);
 		 if(i==3) printf("\nB(x) = ");
		 else if(i==6) {printf("\nC(x) = "); }  
		 else if(i==(avail-1)) printf(" \n"); 
		 else if (p2[i].expon2==0) printf("  \n");   
		 else printf(" + ");
 	 };
};
