#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 

typedef struct S_Node {      
  char data; 
  struct S_Node *link;   
}S_Node; 

S_Node* top;

int isEmpty()
{
  return (top == NULL);
}

void push(char x) 
{  
  S_Node* tmp=(S_Node *)malloc(sizeof(S_Node));
  tmp->data = x; 
  tmp->link = top;  
  top = tmp; 
} 

char pop() 
{ 
  char x;
  S_Node* tmp=top;
  if(top == NULL) {    
    printf("\n\n Stack is empty !\n");   
    return 0; 
  } 
  else { 
    x = tmp->data;  
    top = tmp->link;   
    free(tmp);        
    return x; 
  } 
} 

char peek() 
{  
  char x; 
  if(top == NULL) {     
    printf("\n\n Stack is empty !\n");   
    return 0;   
  } 
  else { 
    x = top->data; 
    return x; 
  } 
} 

typedef enum{lparen, rparen, plus, minus, multiply, 
             divide, mod, eos, operand} pre_order;

pre_order getToken(char c)
{
  pre_order token;
  switch(c){
    case '('  : token=lparen;   break;
    case ')'  : token=rparen;   break;         
    case '+'  : token=plus;     break;
    case '-'  : token=minus;    break;
    case '*'  : token=multiply; break;
    case '/'  : token=divide;   break;
    case '%'  : token=mod;      break;
    case NULL : token=eos;      break;
    default   : token=operand;   
  } 
  return token;         
} 

int prec(pre_order symbol){
  switch(symbol){
    case lparen   : 
    case rparen   : return 0;         
    case plus     : 
    case minus    : return 1;   
    case multiply : 
    case divide   : 
    case mod      : return 2;  
  } 
}

char* trans_Infix_Postfix(char *exp)
{
  static char postExp[256]="";
  int len=0;
  pre_order token;      
  char  symbol;
  int n=0;  
  
  top = NULL;
  
  symbol = exp[n];
  token = getToken(symbol); 
  
  while(token != eos){
    if(token == operand){
      postExp[len++]=symbol;
      postExp[len]='\0';     
    } 
    else if(token == lparen){
      push(symbol);  
    }    
    else if(token == rparen){    
      while(getToken(peek()) != lparen){                      
        postExp[len++]=pop();
        postExp[len]='\0'; 
      }
      pop();        
    }    
    else{
      while(isEmpty() == 0 && prec(getToken(peek())) >= prec(token)){
        postExp[len++]=pop();
        postExp[len]='\0'; 
      }
      push(symbol);
    }
    symbol = exp[++n];
    token = getToken(exp[n]);        
  }
 
  while( isEmpty() == 0 )
    postExp[len++]=pop();
    
  postExp[len]='\0';

  return postExp;
}

int evalPostfix(char *exp)
{
  pre_order token;     //  ϴ   
  char  symbol;
  int op1, op2;
  int n=0; // Ʈ īƮϱ   
  
  top = NULL;

  symbol = exp[n];
  token = getToken(symbol); 
  while(token != eos){
    if(token == operand){
      push(exp[n] - '0');
    }       
    else{
      op2 = pop();
      op1 = pop();
      switch(token){               
        case plus     : push(op1 + op2); break;
        case minus    : push(op1 - op2); break;
        case multiply : push(op1 * op2); break;
        case divide   : push(op1 / op2); break;
        case mod      : push(op1 % op2); 
      }
    }
    ++n;
    symbol = exp[n];
    token = getToken(symbol); 
  }
  return pop();
}


int main(void) 
{ 
  char* s1 = "(8/2)+(3*5)";          //ڴ ݵ 1ڸ  ش
  char* s2 = "(8/(2+3))*5";          //ڴ ݵ 1ڸ  ش
  char* postE;
  int result;
 
  printf(" Ͽ  ȯϴ (ǥ  ǥ)\n");  
  printf("==============================================================");  
  printf("\n\n");  
  printf("* ǥ(Է°): (8/2)+(3*5)  ");
  postE = trans_Infix_Postfix(s1);
  printf("ǥ(ȯ ): %s", postE); 
  result = evalPostfix(postE); 
  printf("\n ** ǥ  => %d", result);
  
  printf("\n");  
  printf("--------------------------------------------------------------\n");  
  printf("\n");  
  printf("* ǥ(Է°): 8/(2+3)*5  ");  
  postE = trans_Infix_Postfix(s2);
  printf("ǥ(ȯ ): %s", postE); 
  result = evalPostfix(postE); 
  printf("\n ** ǥ  => %d", result);
  printf("\n");  
  printf("==============================================================\n");  
  
  getchar();
}

