#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

typedef struct Q_Node {    
	char data;
	struct Q_Node *link;
} Q_Node;

typedef struct {		
	Q_Node *front, *rear;
} LQ_Type;

LQ_Type *get_LQueue() {
	LQ_Type *LQ;
	LQ = (LQ_Type *)malloc(sizeof(LQ_Type));
	LQ->front = NULL;
	LQ->rear = NULL;
	return LQ;
}

int isEmpty(LQ_Type *LQ) {
	if (LQ->front == NULL) {
		printf(" Linked Queue is empty! ");
		return 1;
	}
	else return 0;
}

void insertLQ(LQ_Type *LQ, char x) {
	Q_Node *newNode = (Q_Node *)malloc(sizeof(Q_Node));
	newNode->data = x;
	newNode->link = NULL;
	if (LQ->front == NULL) {		
		LQ->front = newNode;
		LQ->rear = newNode;
	}
	else {						
		LQ->rear->link = newNode;
		LQ->rear = newNode;
	}
}

char deleteLQ(LQ_Type *LQ) {
	Q_Node *old = LQ->front;
	char x;
	if (isEmpty(LQ)) return 0;
	else {
		x = old->data;
		LQ->front = LQ->front->link;
		if (LQ->front == NULL)
			LQ->rear = NULL;
		free(old);
		return x;
	}
}

char peekLQ(LQ_Type *LQ) {
	char item;
	if (isEmpty(LQ)) return 0;
	else {
		item = LQ->front->data;
		return item;
	}
}

void printLQ(LQ_Type *LQ) {
	Q_Node *tmp = LQ->front;
	printf(" [ ");
	while (tmp) {
		printf("%3c", tmp->data);
		tmp = tmp->link;
	}
	printf(" ] ");
}

void main(void) {
	LQ_Type *LQ = get_LQueue();  
	char data;

	printf("<<ü  ̿ ť(queue)  >>\n");

	while(1) {
		printf("\n---- Selection number(1, or 2, or 0) ---\n");
		printf("  1.insertion    2.deletion  0.end \n");
  	    printf("----------------------------------------\n");
				
		switch(getch()) {
  	        printf("----- Press character ------------------\n");
		    case '1': printf(" Ʈ ť : "); data = getch();
	                  insertLQ(LQ, data); printLQ(LQ);
					  break;
		    case '2': data = peekLQ(LQ);    
					  printf(" ˻ : %c \n", data);
					  data = deleteLQ(LQ); printLQ(LQ);
	                  printf("\t Ʈ ť : %c", data);
				      break; 
		    case '0': return;
		}	
	} 
  getchar();
}