#include <stdio.h>
#include <conio.h>
#include <ctype.h>

#define null 0

struct threaded_node
  {
    unsigned int left_tag;
    int left_link;
    char data;
    int right_link;
    unsigned int right_tag;
  };

struct threaded_node tree[11]={{1,1,'^',0,1},
			       {1,2,'A',3,1},
			       {1,4,'B',5,1},
			       {1,6,'C',7,1},
			       {1,8,'D',9,1},
			       {0,2,'E',1,0},
			       {0,1,'F',3,0},
			       {0,3,'G',0,0},
			       {0,0,'H',4,0},
			       {0,4,'I',2,0}};

void threaded_inorder(int p);
int t_successor(int p);
void threaded_insert(int ken, int boo);

main()
{
  int p, i;

  printf("\n\n*** inorder traversal by threaded binary search tree ***\n\n");

  printf("index left_tag left_link data right_link right_tag\n");
  printf("----- --------- --------- ---- ---------- ---------\n");
  for(i=0; i<10; i++)
     printf("[%d] %9d %9d   %c %9d %9d\n", i, tree[i].left_tag,\
	     tree[i].left_link,tree[i].data, tree[i].right_link,\
	     tree[i].right_tag);
  threaded_inorder(0);

  printf("\n\n Position for insert node: "); scanf("%d", &p);
  printf("\t and data: "); tree[10].data=getche();
  threaded_insert(p, 10);
  
  printf("\n----- --------- --------- ---- ---------- ---------\n");
  for(i=0; i<11; i++)
     printf("[%d] %9d %9d   %c %9d %9d\n", i, tree[i].left_tag,\
	     tree[i].left_link,tree[i].data, tree[i].right_link,\
	     tree[i].right_tag);

  threaded_inorder(0);

  getchar();
}

void threaded_inorder(int p)
{
  int hd;

  hd=p;
  printf("\n\n inorder: ");

  do {
       p=t_successor(p);
       if(p!=hd)
	 printf("%c(%d)  ", tree[p].data, p);
  } while(p != hd);
}

int t_successor(int p)
{
   int m;
   m=tree[p].right_link;
   if(tree[p].right_tag==1)
     while(tree[m].left_tag==1)
	m=tree[m].left_link;
   return(m);
}

void threaded_insert(int ken, int boo)
{
  int w;

  tree[boo].right_link = tree[ken].right_link;
  tree[boo].right_tag = tree[ken].right_tag;
  tree[boo].left_link = ken;
  tree[boo].left_tag = 0;
  tree[ken].right_link = boo;
  tree[ken].right_tag = 1;
  if(tree[boo].right_tag == 1)
     {
       w = t_successor(boo);
       tree[w].left_link = boo;
     }
}
