#include <stdio.h>
#include <stdlib.h>
#define MAX_V 20
#define N 4     
#define M 3     
#define S 7     
#define P 3     

typedef struct g_adjNode {
	int vertex;							
	struct g_adjNode* link;				
} g_adjNode;

typedef struct gKind {
	int n;								
	g_adjNode* adjHead[MAX_V];	
} gKind;

void getGraph(gKind* g) {
	int i;
	g->n = 0;							
	for (i = 0; i<MAX_V; i++)
		g->adjHead[i] = NULL;			
}

void add_V(gKind* g, int v) {
	if (((g->n) + 1)>MAX_V) {
		printf("\n ׷    !");
		return;
	}
	g->n++;								
}

void add_E(gKind* g, int x, int y) {
	g_adjNode* n;

	if (x >= g->n || y >= g->n) {
		printf("\n ׷   ");
		return;
	}
	n = (g_adjNode *)malloc(sizeof(g_adjNode));
	n->vertex = y;
	n->link = g->adjHead[x];	
	g->adjHead[x] = n;
}

void print_adjL(gKind* g) {
	int i;
	g_adjNode* p;
	for (i = 0; i<g->n; i++) {
		printf("\n %d", i+1);
		p = g->adjHead[i];
		while (p) {
			printf(" -> %d", p->vertex+1);
			p = p->link;
		}
	}
}

void main() {
	int i;
	gKind *G1, *G2, *G3, *G4;
 	
	while(1) {
		printf("\n---- Selection number(1, or 2, or 3, or 4, or 0) ----\n");
		printf("1 G1׷[ 4], 2 G2[3], 3 G3[7], 4 G4[3], 0 end \n");
  	    printf("------------------------------------------------------\n");
		G1 = (gKind *)malloc(sizeof(gKind)); getGraph(G1);
		G2 = (gKind *)malloc(sizeof(gKind)); getGraph(G2);
	    G3 = (gKind *)malloc(sizeof(gKind)); getGraph(G3);
		G4 = (gKind *)malloc(sizeof(gKind)); getGraph(G4);
		
		switch(getch()) {
  	        case '1': printf("G1 ׷ "); 
				      for (i = 0; i<N; i++)    
	                      add_V(G1, i);
					  add_E(G1, 0, 3); add_E(G1, 0, 2); add_E(G1, 0, 1);
	                  add_E(G1, 1, 3); add_E(G1, 1, 2); add_E(G1, 1, 0);
	                  add_E(G1, 2, 3); add_E(G1, 2, 1); add_E(G1, 2, 0);
	                  add_E(G1, 3, 2); add_E(G1, 3, 1); add_E(G1, 3, 0);   
                      printf("\n===   Ʈ G1 ===\n");
	                  print_adjL(G1); printf("\n");
	                  break;
		    case '2': printf("G2 ׷ ");
				      for (i = 0; i<M; i++)
                           add_V(G2, i);	
	                  add_E(G2, 0, 2); add_E(G2, 0, 1);
					  add_E(G2, 1, 2); add_E(G2, 1, 0);
	                  add_E(G2, 2, 1); add_E(G2, 2, 0);
                      printf("\n===   Ʈ G2 ===\n");
	                  print_adjL(G2); printf("\n");
  				      break; 
			case '3': printf("G3 ׷ ");
				      for (i = 0; i<S; i++)
    	                   add_V(G3, i);	
	                  add_E(G3, 0, 2); add_E(G3, 0, 1);
					  add_E(G3, 1, 4); add_E(G3, 1, 3);
	                  add_E(G3, 2, 6); add_E(G3, 2, 5);
					  add_E(G3, 3, 1); add_E(G3, 4, 1);
                      add_E(G3, 5, 2); add_E(G3, 6, 2);
                      printf("\n===   Ʈ G3 ===\n");
	                  print_adjL(G3); printf("\n");
					  break; 
		    case '4': printf("G4 ׷ ");
				      for (i = 0; i<P; i++)
                   	       add_V(G4, i);	
	                  add_E(G4, 0, 2); add_E(G4, 0, 0); add_E(G4, 0, 1);
					  add_E(G4, 1, 2); add_E(G4, 1, 0);
                      printf("\n===   Ʈ G4 ===\n");
	                  print_adjL(G4); printf("\n");
					  break;
		    case '0': return;
		}	
	} 
 getchar();   
}