#include <stdio.h>
#include <memory.h>
#include <stdlib.h>
#define MAX_V 10
#define N 4     
#define S 7     

#define FALSE 0
#define TRUE 1

typedef struct g_adjNode {
	int vertex;
	struct g_adjNode* link;
}g_adjNode;

typedef struct gKind {
	int n;								
	g_adjNode* adjHead[MAX_V];	
	int check_v[MAX_V];			
}gKind;

void getGraph(gKind* g) {
	int v;
	g->n = 0;						
	for (v = 0; v<MAX_V; v++) {
		g->check_v[v] = FALSE;		
		g->adjHead[v] = NULL;		
	}
}

void add_V(gKind* g, int v) {
	if (((g->n) + 1)>MAX_V) {
		printf("\n ׷  ʰ !");
		return;
	}
	g->n++;
}

void add_E(gKind* g, int x, int y) {
	g_adjNode* node;
	if (x >= g->n || y >= g->n) {
		printf("\n ׷  !");
		return;
	}
	node = (g_adjNode *)malloc(sizeof(g_adjNode));
	node->vertex = y;
	node->link = g->adjHead[x];
	g->adjHead[x] = node;
}

void print_adjL(gKind* g) {
	int i;
	g_adjNode* p;
	for (i = 0; i<g->n; i++) {
		printf("\n %d ", i + 1);
		p = g->adjHead[i];
		while (p) {
			printf(" -> %d", p->vertex + 1);
			p = p->link;
		}
	}
}

typedef int element;

typedef struct sNode {
	int data;
	struct sNode *link;
} sNode;

sNode* top;

int isEmpty() {
	if (top == NULL) return 1;
	else return 0;
}

void push_Stack(int item) {
	sNode* temp = (sNode *)malloc(sizeof(sNode));
	temp->data = item;
	temp->link = top;
	top = temp;
}

int pop_Stack() {
	int x;
	sNode* tmp = top;

	if (isEmpty()) {
		printf("\n\n   !\n");
		return 0;
	}
	else {
		x = tmp->data;
		top = tmp->link;
		free(tmp);
		return x;
	}
} 

void DFS_adjL(gKind* g, int v) {
	g_adjNode* w;
	top = NULL;					
	push_Stack(v);					
	g->check_v[v] = TRUE;		 
	printf(" %d", v + 1);

	while (!isEmpty()) {
		v = pop_Stack();
		w = g->adjHead[v];
		while (w) {
			if (!g->check_v[w->vertex]) {
				if(isEmpty()) push_Stack(v); 
				push_Stack(w->vertex);					
				g->check_v[w->vertex] = TRUE;	
				printf(" -> %d", w->vertex + 1);	
				v = w->vertex;
				w = g->adjHead[v];
			}
			else w = w->link;
		}
	} 
}

void main() {
	int i;
	gKind *G6, *G3;


	while(1) {
		printf("\n\n------ Selection number(1 / 2 / 0 ) ------\n");
		printf("1 G6[4] / 2 G3[7] / 0 end \n");
  	    printf("--------------------------------------------------------------\n");
	
		G6 = (gKind *)malloc(sizeof(gKind)); getGraph(G6);
	    G3 = (gKind *)malloc(sizeof(gKind)); getGraph(G3);
	
		switch(getch()) {
			 case '1': printf("\n---  ḮƮ(G6) ---");
 				      for (i = 0; i<N; i++)    
	                      add_V(G6, i);
					  add_E(G6, 0, 2); add_E(G6, 0, 1);
	                  add_E(G6, 1, 3); add_E(G6, 1, 0);
	                  add_E(G6, 2, 3); add_E(G6, 2, 0); 
	                  add_E(G6, 3, 2); add_E(G6, 3, 1);   
 	                  print_adjL(G6); printf("\n");
					  printf("\n\n===̿켱Ž(DFS)===\n");
				      DFS_adjL(G6, 0);
	                  break;
			case '2': printf("\n---  ḮƮ(G3) ---");
				      for (i = 0; i<S; i++)
    	                   add_V(G3, i);	
	                  add_E(G3, 0, 2); add_E(G3, 0, 1);
					  add_E(G3, 1, 4); add_E(G3, 1, 3);
	                  add_E(G3, 2, 6); add_E(G3, 2, 5);
					  add_E(G3, 3, 1); add_E(G3, 4, 1);
                      add_E(G3, 5, 2); add_E(G3, 6, 2);
                      print_adjL(G3); printf("\n");
					  printf("\n\n===̿켱Ž(DFS)===\n");
				      DFS_adjL(G3, 0);
					  break; 
  		    case '0': return;
		}

	}
   getchar();
}

