#include <stdio.h>
#include <memory.h>
#include <stdlib.h>
#define MAX_V 10
#define N 4     
#define S 7     

#define FALSE 0
#define TRUE 1

typedef struct g_adjNode {
	int vertex;
	struct g_adjNode* link;
}g_adjNode;

typedef struct gKind {
	int n;								
	g_adjNode* adjHead[MAX_V];	
	int check_v[MAX_V];			
}gKind;

void getGraph(gKind* g) {
	int v;
	g->n = 0;						
	for (v = 0; v<MAX_V; v++) {
		g->check_v[v] = FALSE;		
		g->adjHead[v] = NULL;		
	}
}

void add_V(gKind* g, int v) {
	if (((g->n) + 1)>MAX_V) {
		printf("\n ׷   ʰ!");
		return;
	}
	g->n++;
}

void add_E(gKind* g, int x, int y) {
	g_adjNode* node;
	if (x >= g->n || y >= g->n) {
		printf("\n ׷  !");
		return;
	}
	node = (g_adjNode *)malloc(sizeof(g_adjNode));
	node->vertex = y;
	node->link = g->adjHead[x];
	g->adjHead[x] = node;
}

void print_adjL(gKind* g) {
	int i;
	g_adjNode* p;
	for (i = 0; i<g->n; i++) {
		printf("\n %d ", i + 1);
		p = g->adjHead[i];
		while (p) {
			printf(" -> %d", p->vertex + 1);
			p = p->link;
		}
	}
}

typedef int element;

typedef struct QNode {
	int data;
	struct QNode *link;
} QNode;

typedef struct {
	QNode *front, *rear;
} Q_Kind;

Q_Kind *getLQ() {
	Q_Kind *LQ;
	LQ = (Q_Kind *)malloc(sizeof(Q_Kind));
	LQ->front = NULL;
	LQ->rear = NULL;
	return LQ;
}

int isEmpty(Q_Kind *LQ) {
	if (LQ->front == NULL) {
		printf("\n ť ! \n");
		return 1;
	}
	else return 0;
}

void insertQ(Q_Kind *LQ, int item) {
	QNode *newNode = (QNode *)malloc(sizeof(QNode));
	newNode->data = item;
	newNode->link = NULL;
	if (LQ->front == NULL) {
		LQ->front = newNode;
		LQ->rear = newNode;
	}
	else {
		LQ->rear->link = newNode;
		LQ->rear = newNode;
	}
}

int deleteQ(Q_Kind *LQ) {
	QNode *old = LQ->front;
	int item;
	if (isEmpty(LQ)) return 0;
	else {
		item = old->data;
		LQ->front = LQ->front->link;
		if (LQ->front == NULL)
			LQ->rear = NULL;
		free(old);
		return item;
	}
}  

void BFS_adjL(gKind* g, int v) {
	g_adjNode* w;
	Q_Kind* Q;				
	Q = getLQ();	
	g->check_v[v] = TRUE;		
	printf(" %d ", v + 1);
	insertQ(Q, v);			

	while (!isEmpty(Q)) {
		v = deleteQ(Q);
		for (w = g->adjHead[v]; w; w = w->link)	
			if (!g->check_v[w->vertex]) {	
				g->check_v[w->vertex] = TRUE;
				printf(" -> %d ", w->vertex + 1); 
				insertQ(Q, w->vertex);
			}
	} 
}

void main() {
	int i;
	gKind *G3, *G6;

	while(1) {
		printf("\n------ Selection number(1 / 2 / 0 ) ------\n");
		printf("1 G6[4] / G3[7] / 0 end \n");
  	    printf("--------------------------------------------------------------\n");
	
		G3 = (gKind *)malloc(sizeof(gKind)); getGraph(G3);
		G6 = (gKind *)malloc(sizeof(gKind)); getGraph(G6);

		switch(getch()) {
			 case '1': printf("\n---  ḮƮ(G6) ---");
 				      for (i = 0; i<N; i++)    
	                      add_V(G6, i);
					  add_E(G6, 0, 2); add_E(G6, 0, 1);
	                  add_E(G6, 1, 3); add_E(G6, 1, 0);
	                  add_E(G6, 2, 3); add_E(G6, 2, 0); 
	                  add_E(G6, 3, 2); add_E(G6, 3, 1);   
 	                  print_adjL(G6); printf("\n");
					  printf("\n\n===ʺ켱Ž(BFS)===\n");
				      BFS_adjL(G6, 0);
	                  break;
			case '2': printf("\n---  ḮƮ(G3) ---");
				      for (i = 0; i<S; i++)
    	                   add_V(G3, i);	
	                  add_E(G3, 0, 2); add_E(G3, 0, 1);
					  add_E(G3, 1, 4); add_E(G3, 1, 3);
	                  add_E(G3, 2, 6); add_E(G3, 2, 5);
					  add_E(G3, 3, 1); add_E(G3, 4, 1);
                      add_E(G3, 5, 2); add_E(G3, 6, 2);
                      print_adjL(G3); printf("\n");
					  printf("\n\n===ʺ켱Ž(BFS)===\n");
				      BFS_adjL(G3, 0);
					  break; 
  		    case '0': return;
		}
	}
   getchar();
}

