#include <stdio.h>
#include <limits.h>

#define TRUE  1
#define FALSE 0
#define MAX_V_D 6						
#define MAX_V_F 3						
#define INF  50000

int w_D[MAX_V_D][MAX_V_D] = {	
	{ 0, 7, 4, 9, 7, INF },
	{ INF, 0, INF, INF, INF, 6},
	{ INF, 1, 0, 3, INF, INF},
	{ INF, INF, INF, 0, INF,3},
	{ INF, INF, INF, 1, 0, 4},
	{ INF, INF, INF, INF, INF, 0},
};

int w_F[MAX_V_F][MAX_V_F] = {	
	{ 2, 8, 5},
	{ 3, 0, INF },
	{ INF, 2, 0},
};  

int dis_D[MAX_V_D];			
int S_D[MAX_V_D];	
int A_F[MAX_V_F][MAX_V_F];			

int nextVertex_D(int n) {
	int i, min, minPos;
	min = INT_MAX;
	minPos = -1;
	for (i = 0; i< n; i++)
		if ((dis_D[i] < min) && !S_D[i]) {
			min = dis_D[i];
			minPos = i;
		}
	return minPos;
}

int pStep_D(int step) {
	int i;
	printf("\n %3d step: S={", step);
	for (i = 0; i < MAX_V_D; i++)
		if (S_D[i] == TRUE)
			printf("%3c", i + 97);

	if (step<2) printf(" } \t\t\t");
	else if (step<4) printf(" } \t\t");
	else printf(" } \t");
	printf(" distance :[ ");
	for (i = 0; i < MAX_V_D; i++)
		if (dis_D[i] == 50000)
			printf("%3c", '*');
		else printf("%3d", dis_D[i]);
		printf("%3c", ']');
		return ++step;
   printf("\n"); 
}

void Dijkstra_sPath(int start, int n) {
	int i, u, w, step = 0;

	for (i = 1; i < n; i++) {	
		dis_D[i] = w_D[start][i];
		S_D[i] = FALSE;
	}

	S_D[start] = TRUE;			
	dis_D[start] = 0;		

	step = pStep_D(0);		

	for (i = 0; i < n - 1; i++) {
		u = nextVertex_D(n);		
		S_D[u] = TRUE;			
		for (w = 0; w < n; w++)
			if (!S_D[w])			
				if (dis_D[u] + w_D[u][w] < dis_D[w])
					dis_D[w] = dis_D[u] + w_D[u][w];	

		step = pStep_D(step);	
	}
}

void pStep_F(int step) {					
	int i, j;
	printf(" A%d : ", step);
	for (i = 0; i < MAX_V_F; i++) {
		printf("\t");
		for (j = 0; j < MAX_V_F; j++) {
			if (A_F[i][j] == 50000)
				printf("%4c", '*');
			else printf("%4d", A_F[i][j]);
		}
		printf("\n");
	}
}

void Floyd_sPath(int n) {
	int v, w, k, step = -1;

	for (v = 0; v < n; v++)		
		for (w = 0; w < n; w++)
			A_F[v][w] = w_F[v][w];

	pStep_F(step);

	for (k = 0; k < n; k++) {
		for (v = 0; v < n; v++)
			for (w = 0; w < n; w++)
				if (A_F[v][k] + A_F[k][w] < A_F[v][w])
					A_F[v][w] = A_F[v][k] + A_F[k][w];
		pStep_F(++step);
	}
}

void main(void) {
	int i, j;
	
	while(1) {
	    printf("\n\n********** ִ (Shortest Path) ϱ **********\n");
		printf("------ Selection number(1 / 2 / 0 ) ------\n");
		printf("1 ͽƮ  / 2 ÷̵  / 0 end \n");
  	    printf("--------------------------------------------------------------\n");
	
		switch(getch()) {
			 case '1': printf("********** ġ  (6*6) **********\n");
   	                   for (i = 0; i < MAX_V_D; i++) {
		                   for (j = 0; j < MAX_V_D; j++) {
			                   if (w_D[i][j] == 50000)
				                   printf("%3c", '*');
			                   else printf("%3d", w_D[i][j]);
		                   }
		               printf("\n");
	                   }
					   printf("***** ͽƮ  *****");
	                   Dijkstra_sPath(0, MAX_V_D);
  				       break;
		    case '2': printf("********** ġ  (3*3) **********\n");
   	                   for (i = 0; i < MAX_V_F; i++) {
		                   for (j = 0; j < MAX_V_F; j++) {
			                   if (w_F[i][j] == 50000)
				                  printf("%3c", '*');
			                   else printf("%3d", w_F[i][j]);
		                   }
		               printf("\n");
	                   }
					  printf("***** ÷̵  *****\n");
 	                  Floyd_sPath(MAX_V_F);
 				      break; 
			case '0': return;
		}
	}
	getchar();
}